## intrusive-shared-ptr 1.4

=== CMakeLists.txt ===
#
# Copyright 2004 Eugene Gershnik
#
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file or at
# https://github.com/gershnik/intrusive_shared_ptr/blob/master/LICENSE.txt
#

cmake_minimum_required(VERSION 3.25)

file(READ VERSION ISPTR_VERSION)
if (NOT ISPTR_VERSION)
    message(FATAL_ERROR "Cannot determine library version (VERSION file not found)")
endif()
string(STRIP ${ISPTR_VERSION} ISPTR_VERSION)

project(isptr VERSION ${ISPTR_VERSION} LANGUAGES CXX)

set(SRCDIR ${CMAKE_CURRENT_LIST_DIR})
set(LIBNAME isptr)

add_library(${LIBNAME} INTERFACE)

target_include_directories(${LIBNAME}
INTERFACE
    $<BUILD_INTERFACE:${SRCDIR}/inc>
    $<INSTALL_INTERFACE:include>  # <prefix>/include
)

set(PUBLIC_HEADERS 
    ${SRCDIR}/inc/intrusive_shared_ptr/intrusive_shared_ptr.h
    ${SRCDIR}/inc/intrusive_shared_ptr/apple_cf_ptr.h
    ${SRCDIR}/inc/intrusive_shared_ptr/com_ptr.h
    ${SRCDIR}/inc/intrusive_shared_ptr/python_ptr.h
    ${SRCDIR}/inc/intrusive_shared_ptr/refcnt_ptr.h
    ${SRCDIR}/inc/intrusive_shared_ptr/ref_counted.h
)

target_sources(${LIBNAME} 
INTERFACE 
    FILE_SET HEADERS BASE_DIRS ${SRCDIR}/inc FILES
        ${PUBLIC_HEADERS}
PRIVATE 
    ${PUBLIC_HEADERS}
)

add_library(intrusive-shared-ptr ALIAS isptr)
add_library(isptr::isptr ALIAS isptr)

if (PROJECT_IS_TOP_LEVEL)

    include(cmake/install.cmake)

    add_subdirectory(test)

endif()

=== test/CMakeLists.txt ===
#cmake_policy(SET CMP0092 NEW)

if (WIN32)
set(CMAKE_SYSTEM_VERSION "10.0.19041.0" CACHE STRING "Windows SDK Version" FORCE)
endif()


find_package (Python3 COMPONENTS Interpreter Development)

if(${Python3_Development_FOUND})
    include_directories(
    SYSTEM
        ${Python3_INCLUDE_DIRS}
    )

    link_libraries(
        ${Python3_LIBRARIES}
    )
endif()

set (TEST_SUFFIXES
    17
    20
)

set(CXX_STANDARD_17 17)
set(CXX_STANDARD_20 20)

set(TEST_COMMAND "")

foreach(TEST_SUFFIX ${TEST_SUFFIXES})

    add_executable(test-${TEST_SUFFIX})

    set_target_properties(test-${TEST_SUFFIX} PROPERTIES
        CXX_STANDARD ${CXX_STANDARD_${TEST_SUFFIX}}
        CXX_STANDARD_REQUIRED OFF
        CXX_EXTENSIONS OFF
        CXX_VISIBILITY_PRESET hidden
        VISIBILITY_INLINES_HIDDEN ON
    )

    target_link_libraries(test-${TEST_SUFFIX} PRIVATE
        isptr::isptr
    )

    target_compile_options(test-${TEST_SUFFIX} PRIVATE
        $<$<CXX_COMPILER_ID:MSVC>:/W4;/WX>
        $<$<CXX_COMPILER_ID:Clang>:-Wall;-Wextra;-pedantic;-Wno-self-assign-overloaded;-Wno-self-move>
        $<$<CXX_COMPILER_ID:AppleClang>:-Wall;-Wextra;-pedantic;-Wno-self-assign-overloaded;-Wno-self-move>
        $<$<CXX_COMPILER_ID:GNU>:-Wall;-Wextra;-pedantic>
    )

    target_link_libraries(test-${TEST_SUFFIX} PRIVATE
        "$<$<PLATFORM_ID:Darwin>:-framework CoreFoundation>"
    )

    target_compile_definitions(test-${TEST_SUFFIX} PRIVATE
        $<$<BOOL:${Python3_Development_FOUND}>:ISPTR_USE_PYTHON=1>
    )

    target_sources(test-${TEST_SUFFIX} PRIVATE

        test_apple_cf_ptr.cpp
        test_atomic.cpp
        test_com_ptr.cpp
        test_python_ptr.cpp
        test_general.cpp
        test_main.cpp
        test_ref_counted.cpp
        test_ref_counted_st.cpp
        test_weak_ref_counted.cpp
        test_weak_ref_counted_st.cpp
        test_abstract_ref_counted.cpp
        test_abstract_ref_counted_st.cpp
        test_delegating_traits.cpp

        mocks.h
        catch.hpp
    )

    list(APPEND TEST_COMMAND COMMAND)
    list(APPEND TEST_COMMAND test-${TEST_SUFFIX})

endforeach()

add_custom_target(run-test 
    ${TEST_COMMAND}
)

=== debian/changelog ===
intrusive-shared-ptr (1.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Sat, 25 May 2024 22:13:34 +0200

intrusive-shared-ptr (1.4-1) experimental; urgency=medium

  * Initial Debian release.

 -- Dylan Aïssi <daissi@debian.org>  Thu, 23 May 2024 21:39:55 +0200

=== debian/control ===
Source: intrusive-shared-ptr
Section: libdevel
Priority: optional
Maintainer: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/gershnik/intrusive_shared_ptr
Vcs-Browser: https://salsa.debian.org/debian/isptr
Vcs-Git: https://salsa.debian.org/debian/isptr.git

Package: libisptr-dev
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: another implementation of an intrusive reference counting smart
 isptr is yet another implementation of an intrusive reference counting smart
 pointer, highly configurable reference counted base class and adapters.

## intrusive-shared-ptr 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,11 @@
 string(STRIP ${ISPTR_VERSION} ISPTR_VERSION)
 
 project(isptr VERSION ${ISPTR_VERSION} LANGUAGES CXX)
+
+
+option(ISPTR_PROVIDE_MODULE "whether C++ module target should be provided" OFF)
+option(ISPTR_ENABLE_PYTHON "whether to enable Python support in C++ module" OFF)
+
 
 set(SRCDIR ${CMAKE_CURRENT_LIST_DIR})
 set(LIBNAME isptr)
@@ -44,8 +49,66 @@
     ${PUBLIC_HEADERS}
 )
 
-add_library(intrusive-shared-ptr ALIAS isptr)
-add_library(isptr::isptr ALIAS isptr)
+add_library(intrusive-shared-ptr ALIAS ${LIBNAME})
+add_library(${LIBNAME}::${LIBNAME} ALIAS ${LIBNAME})
+
+if(ISPTR_PROVIDE_MODULE)
+
+    if(ISPTR_ENABLE_PYTHON AND NOT Python3_Development_FOUND)
+        find_package (Python3 COMPONENTS Development REQUIRED)
+    endif()
+
+    add_library(${LIBNAME}m_helper INTERFACE)
+    add_library(${LIBNAME}m::helper ALIAS ${LIBNAME}m_helper)
+
+    if (ISPTR_ENABLE_PYTHON)
+
+        target_include_directories(${LIBNAME}m_helper SYSTEM
+        INTERFACE
+            ${Python3_INCLUDE_DIRS}
+        )
+
+        target_link_libraries(${LIBNAME}m_helper 
+        INTERFACE
+            ${Python3_LIBRARIES}
+        )
+
+        target_compile_definitions(${LIBNAME}m_helper 
+        INTERFACE
+            ISPTR_ENABLE_PYTHON=1
+        )
+
+    endif()
+
+    add_library(${LIBNAME}m OBJECT)
+
+    target_compile_features(${LIBNAME}m
+    PUBLIC
+        cxx_std_20
+    )
+
+    set_target_properties(${LIBNAME}m PROPERTIES
+        CXX_STANDARD 20
+        CXX_STANDARD_REQUIRED ON
+        CXX_EXTENSIONS OFF
+        CXX_VISIBILITY_PRESET hidden
+        VISIBILITY_INLINES_HIDDEN ON 
+    )
+
+    target_link_libraries(${LIBNAME}m
+    PRIVATE
+        $<BUILD_INTERFACE:${LIBNAME}m::helper>
+    )
+
+    target_sources(${LIBNAME}m
+    PUBLIC 
+        FILE_SET CXX_MODULES BASE_DIRS ${SRCDIR}/modules FILES
+            ${SRCDIR}/modules/isptr.cppm
+    )
+
+    add_library(${LIBNAME}m::${LIBNAME}m ALIAS ${LIBNAME}m)
+
+endif()
 
 if (PROJECT_IS_TOP_LEVEL)

=== test/CMakeLists.txt ===
#cmake_policy(SET CMP0092 NEW)

if (WIN32)
set(CMAKE_SYSTEM_VERSION "10.0.19041.0" CACHE STRING "Windows SDK Version" FORCE)
endif()


include(FetchContent)

FetchContent_Declare(doctest
    URL  https://raw.githubusercontent.com/doctest/doctest/v2.4.11/doctest/doctest.h
    DOWNLOAD_NO_EXTRACT TRUE
)

FetchContent_MakeAvailable(doctest)

if(ISPTR_ENABLE_PYTHON AND NOT Python3_Development_FOUND)
    find_package (Python3 COMPONENTS Development REQUIRED)
endif()


set (TEST_SUFFIXES
    17
    20
)

set(CXX_STANDARD_17 17)
set(CXX_STANDARD_20 20)

set(TEST_VARIANTS_17 "headers")
if (${ISPTR_PROVIDE_MODULE})
    set(TEST_VARIANTS_20 "headers;module")
else()
    set(TEST_VARIANTS_20 "headers")
endif()

set(TEST_COMMAND "")

foreach(TEST_SUFFIX ${TEST_SUFFIXES})

    foreach(TEST_VARIANT ${TEST_VARIANTS_${TEST_SUFFIX}})

        set(TEST_TARGET_NAME test-${TEST_SUFFIX}-${TEST_VARIANT})

        add_executable(${TEST_TARGET_NAME})

        set_target_properties(${TEST_TARGET_NAME} PROPERTIES
            CXX_STANDARD ${CXX_STANDARD_${TEST_SUFFIX}}
            CXX_STANDARD_REQUIRED OFF
            CXX_EXTENSIONS OFF
            CXX_VISIBILITY_PRESET hidden
            VISIBILITY_INLINES_HIDDEN ON 
        )

        if("${TEST_VARIANT}" STREQUAL "module")
            set_target_properties(${TEST_TARGET_NAME} PROPERTIES
                CXX_SCAN_FOR_MODULES ON
            )
        endif()

        target_include_directories(${TEST_TARGET_NAME} PRIVATE
            ${doctest_SOURCE_DIR}
        )

        if (ISPTR_ENABLE_PYTHON)
            target_link_libraries(${TEST_TARGET_NAME} PRIVATE
                ${Python3_LIBRARIES}
            )
            target_include_directories(${TEST_TARGET_NAME} SYSTEM PRIVATE
                ${Python3_INCLUDE_DIRS}
            )
        endif()

        target_link_libraries(${TEST_TARGET_NAME} PRIVATE
            "$<$<PLATFORM_ID:Darwin>:-framework CoreFoundation>"
            $<IF:$<STREQUAL:${TEST_VARIANT},module>,isptrm::isptrm,isptr::isptr>
        )

        target_compile_options(${TEST_TARGET_NAME} PRIVATE
            $<$<CXX_COMPILER_ID:MSVC>:/W4;/WX>
            $<$<CXX_COMPILER_ID:Clang>:-Wall;-Wextra;-pedantic;-Wno-self-assign-overloaded;-Wno-self-move>
            $<$<CXX_COMPILER_ID:AppleClang>:-Wall;-Wextra;-pedantic;-Wno-self-assign-overloaded;-Wno-self-move>
            $<$<CXX_COMPILER_ID:GNU>:-Wall;-Wextra;-pedantic;-Wno-self-move>
        )

        target_compile_definitions(${TEST_TARGET_NAME} PRIVATE
            $<$<BOOL:${ISPTR_ENABLE_PYTHON}>:ISPTR_USE_PYTHON=1>
            $<$<STREQUAL:${TEST_VARIANT},module>:ISPTR_USE_MODULES=1>
            _FILE_OFFSET_BITS=64  # prevents weird issues with modules and clang on Ubuntu
        )

        target_sources(${TEST_TARGET_NAME} PRIVATE

            test_apple_cf_ptr.cpp
            test_atomic.cpp
            test_com_ptr.cpp
            test_python_ptr.cpp
            test_general.cpp
            test_main.cpp
            test_ref_counted.cpp
            test_ref_counted_st.cpp
            test_weak_ref_counted.cpp
            test_weak_ref_counted_st.cpp
            test_abstract_ref_counted.cpp
            test_abstract_ref_counted_st.cpp
            test_delegating_traits.cpp

            mocks.h
        )

        list(APPEND TEST_COMMAND COMMAND)
        list(APPEND TEST_COMMAND echo Running: ${TEST_TARGET_NAME})
        list(APPEND TEST_COMMAND COMMAND)
        list(APPEND TEST_COMMAND ${TEST_TARGET_NAME})

    endforeach()

endforeach()

add_custom_target(run-test 
    ${TEST_COMMAND}
)

=== debian/changelog ===
intrusive-shared-ptr (1.5-1) unstable; urgency=medium

  * New upstream version 1.5
  * Add doctest-dev in Build-Deps
  * Add patch to use system doctest for building unit tests
  * Update debian/copyright

 -- Dylan Aïssi <daissi@debian.org>  Sun, 13 Oct 2024 14:54:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Dylan Aïssi <daissi@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               cmake
+               cmake,
+               doctest-dev
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/gershnik/intrusive_shared_ptr

## intrusive-shared-ptr 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,7 @@
 
 set(PUBLIC_HEADERS 
     ${SRCDIR}/inc/intrusive_shared_ptr/intrusive_shared_ptr.h
+    ${SRCDIR}/inc/intrusive_shared_ptr/common.h
     ${SRCDIR}/inc/intrusive_shared_ptr/apple_cf_ptr.h
     ${SRCDIR}/inc/intrusive_shared_ptr/com_ptr.h
     ${SRCDIR}/inc/intrusive_shared_ptr/python_ptr.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 FetchContent_Declare(doctest
     URL  https://raw.githubusercontent.com/doctest/doctest/v2.4.11/doctest/doctest.h
     DOWNLOAD_NO_EXTRACT TRUE
+    SOURCE_DIR downloaded/doctest
 )
 
 FetchContent_MakeAvailable(doctest)
@@ -42,7 +43,7 @@
 
         set(TEST_TARGET_NAME test-${TEST_SUFFIX}-${TEST_VARIANT})
 
-        add_executable(${TEST_TARGET_NAME})
+        add_executable(${TEST_TARGET_NAME} EXCLUDE_FROM_ALL)
 
         set_target_properties(${TEST_TARGET_NAME} PROPERTIES
             CXX_STANDARD ${CXX_STANDARD_${TEST_SUFFIX}}
@@ -59,7 +60,7 @@
         endif()
 
         target_include_directories(${TEST_TARGET_NAME} PRIVATE
-            ${doctest_SOURCE_DIR}
+            ${CMAKE_CURRENT_BINARY_DIR}/downloaded
         )
 
         if (ISPTR_ENABLE_PYTHON)
@@ -117,6 +118,6 @@
 
 endforeach()
 
-add_custom_target(run-test 
+add_custom_target(run-test
     ${TEST_COMMAND}
 )

=== debian/changelog ===
intrusive-shared-ptr (1.6-1) unstable; urgency=medium

  * New upstream version 1.6
  * Drop patch included in upstream release
  * Drop manual installation of common.h, fixed upstream
  * Mark libisptr-dev as 'Multi-Arch: same'
  * Add debian/salsa-ci.yml

 -- Dylan Aïssi <daissi@debian.org>  Wed, 19 Feb 2025 10:21:24 +0100

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
 
 Package: libisptr-dev
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: another implementation of an intrusive reference counting smart

=== debian/watch ===
version=4
https://github.com/gershnik/intrusive_shared_ptr/tags .*/v?(\d.*)@ARCHIVE_EXT@
